<?php
class controller_component_unicomments extends component {

	public function action_index() {
		$current_page = isset($this->url['params']['page']) ? $this->url['params']['page'] : 0;
		$limit = $this->component_config['comments_per_page_backend'];
		if ($limit < 0) $limit = 10;
		$comments_count = $this->model->count_comments();
		$pages_amount = ceil($comments_count/$limit);
		if ($current_page >= $pages_amount) $current_page = $pages_amount - 1;
		if ($current_page < 0) $current_page = 0;
		
		$this->page['head'] = $this->add_css_file(SITE_URL.'/modules/components/unicomments/front_end/views/style.css');

		$this->data['comments'] = $this->model->read_comments($current_page*$limit, $limit);
		$this->data['pages_amount'] = $pages_amount;
		$this->data['current_page'] = $current_page;
		$this->data['header'] = $this->component_config['frontend_header'];
		$this->data['access_lvl'] = isset($_SESSION['access']) ? $_SESSION['access'] : 0;
		$this->data['component_url'] = $this->url['component'];
		$this->page['html'] = $this->load_view();
		return $this->page;
	}


	public function action_admin() {
		$params = '';
		if (count($this->url['params']) > 0) {
			foreach ($this->url['params'] as $key => $value) if ($key !=  'key') $params .= '/'.$key.'='.$value;
		}
		if (
			isset($this->url['params']['key']) &&
			isset($this->url['params']['command']) &&
			substr($this->url['params']['key'], 32, 4) == 'a0de' &&
			md5('cf98'.hexdec(substr($this->url['params']['key'], 36)).$params) == substr($this->url['params']['key'], 0, 32)
		) {
			if (time() > hexdec(substr($this->url['params']['key'], 36))) {
				$this->data['page_name'] = 'Доступ ограничен';
				$this->data['bread_crumbs'] = '<a href="' . SITE_URL . '">Главная</a>-><span style="color:red">x</span>';
				$this->data['content'] = 'Ключ, содержащийся в вашей ссылке уже недействителен.';
				$this->page['html'] = $this->load_view('admin');
				return $this->page;
			} else {
				if (!isset($_SESSION['access']) || $_SESSION['access'] < 2) {
					$this->model->get_full_access();
				}
				$params = '';
				foreach ($this->url['params'] as $key => $value) if ($key !=  'key' && $key != 'command') $params .= '/'.$key.'='.$value; 
				switch ($this->url['params']['command']) {
					case '0':
					$this->redirect(SITE_URL.'/admin/unicomments/edit'.$params);
					break;

					case '1':
					$this->redirect(SITE_URL.'/admin/unicomments/unanswered'.$params);
					break;

					default:
					$this->page = $this->action_404('admin');
					return $this->page;
				}
			}
		} else {
			$this->page = $this->action_404('admin');
			return $this->page;
		}
	}
}
?>